#import <Cocoa/Cocoa.h>

@class XeeImage,XeeController;

@interface XeeDestinationView:NSTableView
{
	BOOL outside,suggest_outside;
}

-(void)awakeFromNib;
-(void)mouseDown:(NSEvent *)event;
-(void)keyDown:(NSEvent *)event;
-(unsigned int)draggingSourceOperationMaskForLocal:(BOOL)local;
-(void)dragImage:(NSImage *)image at:(NSPoint)loc offset:(NSSize)offset event:(NSEvent *)event pasteboard:(NSPasteboard *)pboard source:(id)src slideBack:(BOOL)slide;
-(NSDragOperation)draggingEntered:(id <NSDraggingInfo>)sender;
-(void)draggingExited:(id <NSDraggingInfo>)sender;
-(void)draggedImage:(NSImage *)draggedImage movedTo:(NSPoint)screenPoint;
-(void)draggedImage:(NSImage *)image endedAt:(NSPoint)point operation:(NSDragOperation)op;
-(void)updateData:(id)notification;

@end



@interface XeeDestinationListHandler:NSObject
{
	NSMutableArray *destinations;
	NSIndexSet *lastrowset;
}

-(id)init;
-(id)tableView:(NSTableView *)table objectValueForTableColumn:(NSTableColumn *)column row:(int)row;
-(int)numberOfRowsInTableView:(NSTableView *)table;
-(BOOL)tableView:(NSTableView *)table writeRowsWithIndexes:(NSIndexSet *)rows toPasteboard:(NSPasteboard*)pboard;
-(NSDragOperation)tableView:(NSTableView*)table validateDrop:(id <NSDraggingInfo>)info proposedRow:(int)row proposedDropOperation:(NSTableViewDropOperation)op;
-(BOOL)tableView:(NSTableView*)table acceptDrop:(id <NSDraggingInfo>)info row:(int)row dropOperation:(NSTableViewDropOperation)op;
//-(float)tableView:(NSTableView *)tableView heightOfRow:(int)row;
-(void)deleteLastRows;
-(void)suggestInsertion:(NSString *)directory;
-(void)addDestinations:(NSArray *)directories index:(int)index;
-(int)findDestination:(NSString *)directory;
-(void)removeDestination:(int)index;
-(NSDictionary *)destination:(int)index;
-(void)updateTables;
-(void)saveList;

+(XeeDestinationListHandler *)defaultObject;

@end



@interface XeeCloseButton:NSButton
{
}

-(id)initWithFrame:(NSRect)frame;

@end



#define XeeCollisionCancel 0
#define XeeCollisionReplace 1
#define XeeCollisionRename 2

@interface XeeCollisionPanel:NSWindow
{
	XeeImage *srcimage,*destimage;
	int transfermode;

	IBOutlet XeeController *controller;
	IBOutlet NSImageView *icon;
	IBOutlet NSTextField *titlefield;
	IBOutlet NSTextField *oldsize;
	IBOutlet NSTextField *oldformat;
	IBOutlet NSTextField *olddate;
	IBOutlet NSTextField *newsize;
	IBOutlet NSTextField *newformat;
	IBOutlet NSTextField *newdate;
	IBOutlet NSTextField *namefield;
}

-(void)run:(NSWindow *)window source:(XeeImage *)srcimage destination:(XeeImage *)destimage mode:(int)mode;
-(void)cancelClick:(id)sender;
-(void)renameClick:(id)sender;
-(void)replaceClick:(id)sender;

@end
